/*
 *  Aquamarine the KDE window decorator
 *
 *  Copyright (c) 2006 Dennis Kasprzyk <onestone@beryl-project.org>
 *  Copyright (c) 2006 Volker Krause <vkrause@kde.org>
 *
 *  Uses code of:
 *      Emerald window decorator (www.beryl-project.org)
 *      gtk-window-decorator (www.freedesktop.org/wiki/Software/Compiz)
 *      KWin window manager (www.kde.org)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */

#ifndef AQUAMARINE_SWITCHER_H
#define AQUAMARINE_SWITCHER_H

#include <qpixmap.h>
#include <qwidget.h>
#include <qstring.h>

namespace Aquamarine
{

    class Switcher
    {

      public:
        Switcher (WId wid);
        ~Switcher ();

        void update ();
        void updateGeometry ();

        WId xid () const
        {
            return m_wid;
        }

      private:
        void updateWindowProperties ();

      private:

            WId m_wid;
        WId m_selected;
        QString m_sName;

        QPixmap m_qpixmap;
        QRect m_geometry;
    };

}

#endif
