/*
 *  Aquamarine the KDE window decorator
 *
 *  Copyright (c) 2006 Dennis Kasprzyk <onestone@beryl-project.org>
 *  Copyright (c) 2006 Volker Krause <vkrause@kde.org>
 *
 *  Uses code of:
 *      Emerald window decorator (www.beryl-project.org)
 *      gtk-window-decorator (www.freedesktop.org/wiki/Software/Compiz)
 *      KWin window manager (www.kde.org)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */


#ifndef AQUAMARINE_UTILS_H
#define AQUAMARINE_UTILS_H

#include <X11/Xlib.h>
#include <fixx11h.h>

#include <qwidget.h>

namespace Aquamarine
{
    namespace Atoms
    {
        extern Atom restack_window;
        extern Atom select_window;
        extern Atom mwm_hints;

        extern Atom toolkit_action;
        extern Atom toolkit_action_main_menu;
        extern Atom toolkit_action_run_dialog;
        extern Atom toolkit_action_window_menu;
        extern Atom toolkit_action_force_quit_dialog;

        extern Atom panel_action;
        extern Atom panel_action_main_menu;
        extern Atom panel_action_run_dialog;

        extern Atom manager;
        extern Atom targets;
        extern Atom multiple;
        extern Atom timestamp;
        extern Atom version;
        extern Atom atom_pair;

        extern Atom opacity;
        extern Atom saturation;
        extern Atom brightness;

        extern Atom utf8_string;

        extern Atom dm_name;
        extern Atom dm_sn;

        extern Atom net_frame_window;
        extern Atom net_window_decor;
        extern Atom net_window_decor_sync;
        extern Atom net_wm_moveresize;
        extern Atom net_active_window;

        extern Atom wm_delete_window;
        extern Atom wm_take_focus;
        extern Atom net_wm_context_help;
        extern Atom net_wm_ping;
        extern Atom net_wm_take_activity;
        extern Atom wm_protocols;

        extern Atom net_desktop_viewport;
        extern Atom net_desktop_geometry;

        extern Atom wm_name;
        extern Atom wm_sn;

        void init ();
    }

    extern WId dm_window;

    void trapXError (void);
    int popXError (void);
    bool eventFilter (void *message, long *result);
    void *readXProperty (WId window, Atom property, Atom type, int *items);
    bool readWindowProperty (long wId, long property, long *value);
    bool acquireDmSession (Display * xdisplay, int screen, bool replace);
    void set_dm_check_hint (int screen);
    bool convertProperty (WId w, Atom target, Atom property);
    void handleSelectionRequest (XEvent * event);

    unsigned short readWindowPropertyDefault (WId id, Atom property,
                                              unsigned short defaultValue);
    void setWindowProperty (WId id, Atom property, unsigned short value);

    bool validWindow (WId id);
}

#endif
